;*******************************************************************************
;    +  +   08.2017 
;*******************************************************************************
 list p=16f676
#include <p16f676.inc>
; __config 0x3FA4
 __CONFIG _FOSC_INTRCIO & _WDTE_OFF & _PWRTE_ON & _MCLRE_ON & _BOREN_OFF & _CP_OFF & _CPD_OFF
;*********  **********************************************************
	cblock	0x20
		temp:2		;    
		tzit		;  1    
		count		;    
		Pt		;     
		Tz:2		;   
		Yiz:2		;  . H, L
		Yni:2		;    H, L
		Ynu:2		;    H, L
		BCD:4		;    BCD
		Rez:4		;   H--L
		FI:.20		;    
		FU:.20		;    
	endc
;********  ***********************************************************
#define	RS	PORTC,4		; LCD 'RS' /
#define	ENA	PORTC,5		; LCD 'Enable'  
#define	GO_ACP	ADCON0,1	;     
#define	TRIS_W1	TRISA,5		; TRIS 
#define	PORT_W1	PORTA,5		; PORT 
;********  ************************************************************
MASK	set	B'00100000'	;  
;********  **************************************************************
bank0	macro			;  Register Bank 0
	errorlevel +302		;   "...not in bank 0."
	bcf	STATUS,RP0	;  Bank 0
	endm
bank1	macro			;  Register Bank 1
	bsf	STATUS,RP0	;  Bank 1
	errorlevel -302		;   "...not in bank 0."
	endm
;********   *****************************************************
	org	0x0000
	goto	Init
;********  **************************************************************
CHRTBL	addwf	PCL,F
	dt	0x06,0x09,0x09,0x06,0x00,0x00,0x00,0x00	;  ()
;********  ********************************************************
Init	clrf	INTCON
	bank1
	movlw	0x80		;  
	movwf	OPTION_REG	;  PORTA
	movlw	0x07		; PORTA 0-2 
	movwf	TRISA
	movlw	0x00		; PORT 0-5 
	movwf	TRISC
	movlw	0x07		; PORTA 0-2 
	movwf	ANSEL
	movlw	0x30		;   RC 
	movwf	ADCON1
	bank0
	movlw	0x07		; PORTA  
	movwf	CMCON
	clrf	PORTA
	clrf	PORTC
	movlw	0x20		;  
	movwf	FSR
CLRRG	clrf	INDF		;  64 (0x40) 
	incf	FSR,F
	movlw	0x40
	subwf	FSR,W
	btfss	STATUS,Z
	goto	CLRRG
;********   ************************************************
	call	p20m		;  60
	movlw	0x03
	movwf	temp
	movwf	PORTC		; 3   0x30 (Data=8 bit)
	call	LCD_E
	call	p20m
	decfsz	temp,F
	goto	$-3
	movlw	0x02		;  0x20 (Data=4 bit)
	movwf	PORTC
	call	LCD_E
	call	p100u
	movlw	0x28		;  0x28 (Data=4 bit 2 )
	call	O_Cmd
	movlw	0x0C		;  0x0 (.,  )
	call	O_Cmd
	call	My_Sym		;   
	movlw	0x80		;  0x80 (. 0.0)
	call	O_Cmd
	movlw	0x55		;  'U'
	call	O_Dat
	movlw	0x3D		;  '='
	call	O_Dat
	movlw	0x89		;  0x89 (. 8.0)
	call	O_Cmd
	movlw	0x49		;  'I'
	call	O_Dat
	movlw	0x3D		;  '='
	call	O_Dat
	movlw	0xC0		;  0xC0 (. 0.1)
	call	O_Cmd
	movlw	0x50		;  'P'
	call	O_Dat
	movlw	0x3D		;  '='
	call	O_Dat
	movlw	.1
	movwf	tzit
Izmer	call	p20m		;    
;********   ************************************************
	decfsz	tzit,F		;  ?
	goto	Izm		;      
	call	Res_W1		;  "Reset DS18B20"
	andlw	0x01		;         
	btfsc	STATUS,Z
	goto	no_dev		;      
	call	p480u		;  480.
	movlw	0CCh		;  "Skip ROM"
	call	WR_W1
	movlw	0xBE		;  "Read ROM"
	call	WR_W1
	call	RD_W1		;    
	movwf	Yiz+1
	call	RD_W1		;    
	movwf	Yiz
	call	Res_W1		;  "Reset DS18B20"
	movlw	0xCC		;  "Skip ROM"
	call	WR_W1
	movlw	0x44		;  "Convert T" 
	call	WR_W1		; ( DS18B20  )
	movlw	0xC9		;  0xC9 (. 9.1)
	call	O_Cmd
	movlw	0x74		;     
	swapf	Yiz,F
	swapf	Yiz+1,W
	andlw	0x0F
	addwf	Yiz,W
	movwf	Yiz+1
	clrf	Yiz
	movlw	0x74		;  't'
	call	O_Dat
	movlw	0x3D		;  '='
	call	O_Dat
	call	bin2dec
	call	OLTxx
	movlw	0x00		;  ''
	call	O_Dat
	movlw	0x43		;  'C'
	call	O_Dat
	call	OL_
	goto	li1
no_dev	movlw	0xC9		;  0xC9 (. 9.1)
	call	O_Cmd
	movlw	.8
	movwf	count
Li2	call	OL_		;  8  
	decfsz	count,F
	goto	Li2
li1	movlw	.64
	movwf	tzit
;********   *******************************************************
Izm	call	p50u		;    
	movlw	FI
	movwf	FSR
	movlw	0x81		;   0,  , VREF=VDD,
	call	izmi		;  @  Fi
	movlw	FI
	movwf	FSR
	call	SumF
	call	Yni_Yiz
	call	bin2dec
	movlw	0x8B		;  0x8B (. 2.1)
	call	O_Cmd
	call	OLx
	movlw	0x41		;  'A'
	call	O_Dat
;********   *************************************************
	call	p50u
	movlw	FU
	movwf	FSR
	movlw	0x85		;   1,  , VREF=VDD,
	call	izmi
	movlw	FU
	movwf	FSR
	call	SumF
	call	Ynu_Yiz
	call	bin2dec		; Rez --> BCD
	movlw	0x82		;  0x82 (. 2.0)
	call	O_Cmd
	call	OLxx
	movlw	0x56		;  'V'
	call	O_Dat
	call	OL_
	goto	pu0
;******   ****************************************************
; P=I*U Rez = Ini * Ynu
pu0	call	mul16	
	call	D24_10
	call	D24_10		; /100
	call	Yiz_Rez
	call	bin2dec
	movlw	0xC2		;  0xC2 (. 2.1)
	call	O_Cmd
	call	OLxxx
	movlw	0x57		;  'W'
	call	O_Dat
	call	OL_
;******    (0-19)    ******************	
	incf	Pt,F
	movf	Pt,W
	addlw	0xF6
	btfsc	STATUS,C
	clrf	Pt
	goto	Izmer		;    
;******    ********************************************************
izmi	movwf	ADCON0
	call	p50u
	bcf	STATUS,C
	rlf	Pt,W
	addwf	FSR,F
	bsf	GO_ACP
	btfsc	GO_ACP
	goto	$-1
	bcf	STATUS,C
	movf	ADRESH,W
	movwf	INDF
	bank1
	movf	ADRESL,W
	bank0
	incf	FSR,F
	movwf	INDF
	return
;******    X (t)   0 *******************************
OLTxx	movf	BCD+2,W
	btfsc	STATUS,Z
	goto	OL_xx
	movlw	0x30
	addwf	BCD+2,W
	call	O_Dat
	goto	OL_xx
;******    X, (P)   0 *****************************
OLxxx	movf	BCD+3,W
	btfsc	STATUS,Z
	goto	OLxx
	movlw	0x30
	addwf	BCD+3,W
	call	O_Dat
	goto	U_01
;******    , (U)   0 ******************************
OLxx	movf	BCD+2,W
	btfsc	STATUS,Z
	goto	U_02
U_01	movlw	0x30
	addwf	BCD+2,W
	call	O_Dat
U_02	movlw	0x30		; 1- 
	addwf	BCD+1,W
	call	O_Dat
	movlw	0x2C		; 2- 
	goto	U_03
;******    , (I) ********************************************
OLx	movlw	0x30		; 1- 
	addwf	BCD+2,W
	call	O_Dat
	movlw	0x2C		; ','
	call	O_Dat
OL_xx	movlw	0x30		; 2- 
	addwf	BCD+1,W
U_03	call	O_Dat
	movlw	0x30		; 3- 
	addwf	BCD,W
	call	O_Dat
	return
;******        . ****************
OL_	movlw	0x20
	call	O_Dat
	return
;******   @FI --> Yni *****************************************
Yni_Yiz	movf	Yiz,w
	movwf	Yni
	movf	Yiz+1,w
	movwf	Yni+1
	return
;******   @FU --> Ynu *****************************************
Ynu_Yiz	movf	Yiz,w
	movwf	Ynu
	movf	Yiz+1,w
	movwf	Ynu+1
	return
;******  Rez --> Yiz **************************************************
Yiz_Rez	movf	Rez,w
	movwf	Yiz+1
	movf	Rez+1,w
	movwf	Yiz
	return
;******  Yiz --> Rez **************************************************
Rez_Yiz	movf	Yiz,w
	movwf	Rez+1
	movf	Yiz+1,w
	movwf	Rez
	clrf	Rez+2
	return
;******  16   @16  10     10 ***********************
; Yiz + @ F = Yiz    16 
SumF	clrf	Yiz
	clrf	Yiz+1
	movlw	.10
	movwf	count
s2	call	sum
	incf	FSR,F
	incf	FSR,F
	decfsz	count,F
	goto s2
	movlw	.3
	movwf	count
s3	bcf	STATUS,C
	call	Rez_Yiz
	call	D24_10
	call	Yiz_Rez
	return
;******  16   16  **************************************************
; Yiz(H,L) + @FSR(H,L) = Yiz(H,L);    16 	
sum	incf	FSR
	movf	INDF,W
	addwf	Yiz+1,F
	btfss	STATUS,C
	goto	s1
	incf	Yiz,F
s1	decf	FSR,F
	movf	INDF,W
	addwf	Yiz,F
	return
;******  24   10 ***************************************************
; Rez:4 (L,M,S,H) / 10 = Rez (L,H),  - Rez+3, temp
D24_10	clrf	Rez+3
	movlw	.24
	movwf	temp
L248	rlf	Rez,W
	rlf	Rez+1,F
	rlf	Rez+2,F
	rlf	Rez+3,F
	rlf	Rez,F
	movlw	.10
	subwf	Rez+3,F
	btfsc	STATUS,0
	bsf	Rez,0
	btfss	Rez,0
	addwf	Rez+3,F
	decfsz	temp,F
	goto	L248
	return
;******  16   16  *********************************************
; Yni(H,L) * Ynu(H,L) = Rez(L,M,H)
mul16	clrf	Rez+3
	clrf	Rez+2
	clrf	Rez+1
	clrf	Rez
	bsf	Rez+1,7
m1	rrf	Yni,f
	rrf	Yni+1,f
	skpc
	goto	m2
	movf	Ynu+1,w
	addwf	Rez+2,f
	movf	Ynu, w
	skpnc
	incfsz	Ynu, w
	addwf	Rez+3,f
m2	rrf	Rez+3,f
	rrf	Rez+2,f
	rrf	Rez+1,f
	rrf	Rez, f
	skpc
	goto	m1
	return
;******  16 Bit to BCD **************************************************
; : Yiz (H,L), : BCD (L,M,S,H), temp:2 
bin2dec	clrf	BCD
	clrf	BCD+1
	clrf	BCD+2
	clrf	BCD+3
	movlw	.16
	movwf	temp
bin2l1	rlf	Yiz+1,F
	rlf	Yiz,F
	movlw	BCD
	movwf	FSR
	movlw	.8
	movwf	temp+1
bin2l2	rlf	INDF,F
	movlw	-.10
	addwf	INDF,W
	btfsc	STATUS,C
	movwf	INDF
	incf	FSR,F
	decfsz	temp+1,F
	goto	bin2l2
	decfsz	temp,F
	goto	bin2l1
	return
;******    CHRTBL ***************************************
My_Sym	movlw	040H		;   1- 
	call	O_Cmd		;
	movlw	.8		;    
	movwf	count		;
	movf	count,W
	sublw	.8 		;   
	call	CHRTBL		;    W ( RETLW)
	call	O_Dat		;    .
	decfsz	count,F	;
	goto	$-5
	return
;******   LCD ***********************************************************
LCD_E	bsf	ENA		;  
	nop		
	bcf	ENA
	return
O_Dat	movwf	temp		;  
	swapf	temp,W
	andlw	0x0F
	movwf	PORTC
	bsf	RS
	call	LCD_E
	movf	temp,W
	andlw	0x0F
	movwf	PORTC
	bsf	RS
	goto	L01
O_Cmd	movwf	temp		;  
	swapf	temp,W
	andlw	0x0F
	movwf	PORTC
	call	LCD_E
	movf	temp,W
	andlw	0x0F
	movwf	PORTC
L01	call	LCD_E
	bcf	RS
	call	p100u
	return
;******  "Reset DS18B20" ************************************************
Res_W1	bank1
	bcf	TRIS_W1
	bank0
	bcf	PORT_W1		;  
	call	p480u		;  480.
	bsf	PORT_W1		;  
	bank1
	bsf	TRIS_W1
	bank0
	call	p50u		;  50.
	btfsc	PORT_W1
	retlw	0x00
	call	p200u		;  200.
	btfss	PORT_W1
	retlw	0x00
	retlw	0x01
;******  "  DS18B20"  ********************************************
;      W.
WR_W1	bank1
	bcf	TRIS_W1
	bank0
	movwf	temp
	movlw	.8
	movwf	count
WR0	bcf	STATUS,C
	bcf	PORT_W1
	call	p10u
	rrf	temp,f
	btfsc	STATUS,C
	bsf	PORT_W1
	call	p50u
	bsf	PORT_W1
	decfsz	count,f
	goto	WR0
	bank1
	bsf	TRIS_W1
	bank0
	call	p200u
	return
;******  "  DS18B20" ****************************************
;     W
RD_W1	clrf	temp
	movlw	.8
	movwf	count
	bsf	PORT_W1
RD0	bank1
	bcf	TRIS_W1
	bank0
	bcf	PORT_W1
	nop
	nop
	bank1
	bsf	TRIS_W1
	bank0
	bsf	PORT_W1
	call	p10u
	movf	PORTA,W
	andlw	MASK		;   
	bcf	STATUS,C
	btfss	STATUS,Z
	bsf	STATUS,C
	rrf	temp,1
	call	p50u
	decfsz	count,F      
	goto	RD0
	movf	temp,W
	return
;********   *******************************************************
p20m	movlw	.248		;  20
	movwf	Tz
	movlw	.26
	movwf	Tz+1
	decfsz	Tz,F
	goto	$-1
	decfsz	Tz+1,F
	goto	$-3
	return
p480u	movlw	.159		;  480 
	goto	pu
p200u	movlw	.66		;  200 
	goto	pu
p100u	movlw	.32		;  100 
	goto	pu
p50u	movlw	.10		;  50 
	goto	pu
p10u	movlw	.1		;  10 
pu	movwf	Tz
	decfsz	Tz,F
	goto	$-1	
	return
;********   ******************************************************
	end